#include "Hack.h"
#include <stdio.h>
#include <TlHelp32.h>
#include <Psapi.h>
#include <tchar.h>

DWORD FindProcessByName(const char *procName) {
    PROCESSENTRY32 entry;
    entry.dwSize = sizeof(PROCESSENTRY32);

    HANDLE snapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, NULL);

    if (Process32First(snapshot, &entry) == TRUE) {
        while (Process32Next(snapshot, &entry) == TRUE) {
            if (stricmp(entry.szExeFile, procName) == 0) {
				CloseHandle(snapshot);
				return entry.th32ProcessID;
            }
        }
    }

    CloseHandle(snapshot);
	return 0;
}

void EnableDebugPriv() {
    HANDLE hToken;
    LUID luid;
    TOKEN_PRIVILEGES tkp;

    OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken);

    LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &luid);

    tkp.PrivilegeCount = 1;
    tkp.Privileges[0].Luid = luid;
    tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

    AdjustTokenPrivileges(hToken, false, &tkp, sizeof(tkp), NULL, NULL);

    CloseHandle(hToken); 
}

DWORD GetModuleBase(DWORD dwProcessIdentifier, TCHAR *lpszModuleName) { 
   HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwProcessIdentifier); 
   int tries = 20;
   while (tries > 0) {
	   if (hSnapshot == INVALID_HANDLE_VALUE) {
		   hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwProcessIdentifier);
		   Sleep(200);
		   tries--;
	   } else {
			tries = 0;
	   }
   }
   if (hSnapshot == INVALID_HANDLE_VALUE) {
		printf("Invalid process handle\n");
		return 0;
   }
   
   DWORD dwModuleBaseAddress = 0;
      MODULEENTRY32 ModuleEntry32 = {0}; 
      ModuleEntry32.dwSize = sizeof(MODULEENTRY32); 
      if (Module32First(hSnapshot, &ModuleEntry32)) { 
         do {
            if (_tcscmp(ModuleEntry32.szModule, lpszModuleName) == 0) { 
               dwModuleBaseAddress = (DWORD)ModuleEntry32.modBaseAddr; 
               break; 
            } 
         } while(Module32Next(hSnapshot, &ModuleEntry32)); 
      } 
      CloseHandle(hSnapshot); 

   return dwModuleBaseAddress; 
}

DWORD Pointer(HANDLE hProc, DWORD base, DWORD *offset) {
	int buf[1];
	ReadProcessMemory(hProc,(LPVOID)base,(LPVOID)buf,4,NULL);
	
	if (offset == NULL) {
		return buf[0];
	}

	int numOffsets = sizeof(offset)/sizeof(DWORD);
	for (int i = 0; i < numOffsets; i++) {
		ReadProcessMemory(hProc,(LPVOID)(buf[0]+offset[i]),(LPVOID)buf,4,NULL);
	}
	return buf[0];
}

int FindAddressByBytes(HANDLE hProc,const char *b,DWORD *addressBuf,const bool *wildCards) {
	unsigned char *pos = NULL;
	MEMORY_BASIC_INFORMATION blockInfo;
	int result = sizeof(blockInfo);
	int bufferSize = sizeof(addressBuf)/sizeof(DWORD);
	int numBytes = sizeof(b);
	int cA = 0;//current address index
	int cMP = 0;//current memory block position
	int cB = 0;//current byte array position
	char *mem;

	while (result == sizeof(blockInfo)) {
		result = VirtualQueryEx(hProc,pos,&blockInfo,sizeof(blockInfo));
		mem = new char[blockInfo.RegionSize];
		ReadProcessMemory(hProc,blockInfo.BaseAddress,(LPVOID)mem,sizeof(mem),NULL);
		while (cMP != blockInfo.RegionSize) {
			if (wildCards != NULL) {
				if (wildCards[cB]) {
					cMP++;
					cB++;
					if (cB == numBytes) {
						cA++;
						if (cA == bufferSize) {
							return cA;
						}
						cB = 0;
					}
					continue;
				}
			}
			if (mem[cMP] == b[cB]) {
				if (cB == 0) {
					addressBuf[cA] = cMP+(DWORD)blockInfo.BaseAddress;
				}
				cB++;
				if (cB == numBytes) {
					cA++;
					if (cA == bufferSize) {
						return cA;
					}
					cB = 0;
				}
			} else {
				cB = 0;
			}

			cMP++;
		}

		cMP = 0;
		cB = 0;
		pos += blockInfo.RegionSize;
	}

	return cA;
}


int ReadInt(HANDLE hProc,DWORD addr) {
	int iBuf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)iBuf,4,NULL);
	return iBuf[0];
}
short ReadShort(HANDLE hProc,DWORD addr) {
	short sBuf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)sBuf,2,NULL);
	return sBuf[0];
}
char ReadByte(HANDLE hProc,DWORD addr) {
	char cBuf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)cBuf,1,NULL);
	return cBuf[0];
}
float ReadFloat(HANDLE hProc,DWORD addr) {
	float buf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,4,NULL);
	return buf[0];
}
double ReadDouble(HANDLE hProc,DWORD addr) {
	double buf[1];
	ReadProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,8,NULL);
	return buf[0];
}
void WriteInt(HANDLE hProc,DWORD addr,int val) {
	int buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,4,NULL);
}
void WriteShort(HANDLE hProc,DWORD addr,short val) {
	short buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,2,NULL);
}
void WriteByte(HANDLE hProc,DWORD addr,char val) {
	char buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,1,NULL);
}
void WriteFloat(HANDLE hProc,DWORD addr,int val) {
	float buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,4,NULL);
}
void WriteDouble(HANDLE hProc,DWORD addr,double val) {
	double buf[1] = {val};
	WriteProcessMemory(hProc,(LPVOID)addr,(LPVOID)buf,8,NULL);
}